﻿package spec.coderunner {
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.events.KeyboardEvent;
	
	import spec.coderunner.types.*;
	import flash.media.Sound;

	public class CodeRunner {
		private var mroot:MovieClip;
		
		private var prev_stage:int = 0;
		private var main_stage:int = 1;
		// main_stage:
		// 1 - menumain
		// 2 - menuoptions
		// 3 - cinematic
		// 4 - game
		// 5 - gameover
		// 6 - gamewin
		// 7 - credits
		
		private var sounds:Array = new Array();
		private var resources:Array;
		private var handles:Array = new Array();
		private var variables:Array = new Array();
		private var intervariables:Array = new Array();
		private var keysHeld:Array;
		
		private function evKeyD(e:KeyboardEvent):void {
			switch (e.keyCode){
				case 32: // space - restart
				keysHeld["space"] = true;
				break;
				case 37: // left
				keysHeld["aLeft"] = true;
				break;
				case 38: // up
				keysHeld["aUp"] = true;
				break;
				case 39: // right
				keysHeld["aRight"] = true;
				break;
				case 40: // down
				keysHeld["aDown"] = true;
				break;
				case 77: // m - menu
				keysHeld["keyM"] = true;
				break;
				case 83: // s - start
				keysHeld["keyS"] = true;
				break;
				case 90: // burn left
				keysHeld["bLeft"] = true;
				break;
				case 88: // burn right
				keysHeld["bRight"] = true;
				break;
			}
		}
		
		private function evKeyU(e:KeyboardEvent):void {
			switch (e.keyCode){
				case 32: // space - restart
				keysHeld["space"] = false;
				break;
				case 37: // left
				keysHeld["aLeft"] = false;
				break;
				case 38: // up
				keysHeld["aUp"] = false;
				break;
				case 39: // right
				keysHeld["aRight"] = false;
				break;
				case 40: // down
				keysHeld["aDown"] = false;
				break;
				case 77: // m - menu
				keysHeld["keyM"] = false;
				break;
				case 83: // s - start
				keysHeld["keyS"] = false;
				break;
				case 90: // burn left
				keysHeld["bLeft"] = false;
				break;
				case 88: // burn right
				keysHeld["bRight"] = false;
				break;
			}
		}
		
		private function evFrame(e:Event):void {
			if (prev_stage != main_stage){
				switch (prev_stage){
					case 1:
					mroot.hold.removeChild(handles["menumain_bg"]);
					
					handles = new Array();
					variables = new Array();
					break;
					case 4:
					unloadGame();
					break;
				}
				
				prev_stage = main_stage;
				
				switch (main_stage){
					case 1:
					handles["menumain_bg"] = new resources["menumain_bg"]();
					mroot.hold.addChild(handles["menumain_bg"]);
					break;
					// ---
					case 4:
					variables["counters"] = new Array();
					variables["counters"]["lives"] = 3;
					variables["counters"]["bombs"] = 0;
					variables["counters"]["score"] = 0;
					loadGame();
					break;
				}
			}
			
			switch (main_stage){
				case 1:
				if (keysHeld["keyS"]){
					sounds["press"] = new resources["sounds"]["press"]();
					sounds["press"].play(0, 1);
					intervariables["load_level"] = 1;
					intervariables["score"] = 0;
					main_stage = 4;
				}
				break;
				case 4:
				for each (var enemy:CodeRunnerHandle in handles["enemies"]){
					if (enemy is CREnemy1){
						var cr:CREnemy1 = enemy as CREnemy1;
						cr.clock(handles["player"], handles["tiles"], handles["enemies"]);
					}
				}
				
				for each (var collectible:CRCollectible in handles["collectibles"]){
					var sg:int = collectible.clock(handles["player"]);
					variables["counters"]["score"] += sg;
					if (sg != 0){
						sounds["coin"] = new resources["sounds"]["coin"]();
						sounds["coin"].play(0, 1);
					}
				}
				
				handles["player"].clock(keysHeld["aLeft"], keysHeld["aUp"], keysHeld["aRight"], keysHeld["aDown"], keysHeld["bLeft"], keysHeld["bRight"], handles["tiles"], handles["enemies"]);
				if (handles["player"].isDead && !variables["gameover_shown"]){
					variables["gameover_shown"] = true;
					variables["counters"]["lives"]--;
					handles["gameover"] = new resources["gameover"]();
					handles["gameover"].gotoAndPlay(variables["counters"]["lives"] > -1 ? "dead" : "gameover");
					handles["gameover"].x = 320;
					handles["gameover"].y = 240;
					mroot.hold.addChild(handles["gameover"]);
				} else if (!handles["player"].isDead && variables["gameover_shown"]){
					variables["gameover_shown"] = false;
					mroot.hold.removeChild(handles["gameover"]);
				}
				
				if (!handles["player"].isDead && !variables["exit_opened"]){
					var openExit:Boolean = true;
					for each (collectible in handles["collectibles"]){
						if (!collectible.collected){
							openExit = false;
						}
					}
					
					if (openExit){
						handles["exit"].open();
						variables["exit_opened"] = true;
					}
				} else if (!handles["player"].isDead && variables["exit_opened"]){
					if (handles["exit"].clock(handles["player"])){
						sounds["exit"] = new resources["sounds"]["exit"]();
						sounds["exit"].play(0, 1);
						intervariables["load_level"]++;
						intervariables["score"] = variables["counters"]["score"]
						variables["counters"]["lives"]++;
						if (intervariables["load_level"] == resources["levels"].length){
							trace("win");
							main_stage = 1;
						} else {
							restartGame();
						}
					}
				}
				
				if (keysHeld["space"] && variables["gameover_shown"] && (variables["counters"]["lives"] > -1)){
					restartGame();
					sounds["press"] = new resources["sounds"]["press"]();
					sounds["press"].play(0, 1);
				}
				
				if (keysHeld["keyM"] && variables["gameover_shown"] && (variables["counters"]["lives"] < 0)){
					main_stage = 1;
					sounds["press"] = new resources["sounds"]["press"]();
					sounds["press"].play(0, 1);
				}
				
				if (variables["counters"]["lives"] > 9){
					handles["hud"].lifeNum.gotoAndStop("n9");
				} else {
					handles["hud"].lifeNum.gotoAndStop(variables["counters"]["lives"] + 1);
				}
				if (variables["counters"]["bombs"] > 9){
					handles["hud"].bombNum.gotoAndStop("n9");
				} else {
					handles["hud"].bombNum.gotoAndStop(variables["counters"]["bombs"] + 1);
				}
				handles["hud"].lvlNum1.gotoAndStop(int(intervariables["load_level"] / 10) + 1);
				handles["hud"].lvlNum0.gotoAndStop((intervariables["load_level"] % 10) + 1);
				var strScore:String = variables["counters"]["score"].toString();
				if (strScore.length > 7){
					strScore = strScore.substr(strScore.length - 8);
				}
				while (strScore.length < 7){
					strScore = "0" + strScore;
				}
				handles["hud"].scoreNum6.gotoAndStop("n" + strScore.charAt(0));
				handles["hud"].scoreNum5.gotoAndStop("n" + strScore.charAt(1));
				handles["hud"].scoreNum4.gotoAndStop("n" + strScore.charAt(2));
				handles["hud"].scoreNum3.gotoAndStop("n" + strScore.charAt(3));
				handles["hud"].scoreNum2.gotoAndStop("n" + strScore.charAt(4));
				handles["hud"].scoreNum1.gotoAndStop("n" + strScore.charAt(5));
				handles["hud"].scoreNum0.gotoAndStop("n" + strScore.charAt(6));
				break;
			}
		}
		
		public function CodeRunner(nroot:MovieClip, nres:Array){
			mroot = nroot;
			mroot.addEventListener(Event.ENTER_FRAME, evFrame);
			mroot.stage.addEventListener(KeyboardEvent.KEY_DOWN, evKeyD);
			mroot.stage.addEventListener(KeyboardEvent.KEY_UP, evKeyU);
			mroot.stage.focus = mroot.stage;
			
			keysHeld = new Array();
			keysHeld["aLeft"] = false;
			keysHeld["aUp"] = false;
			keysHeld["aRight"] = false;
			keysHeld["aDown"] = false;
			keysHeld["bLeft"] = false;
			keysHeld["bRight"] = false;
			
			resources = nres;
		}
		
		private function restartGame():void {
			unloadGame();
			loadGame();
		}
		
		private function unloadGame():void {
			for each (var row:Array in handles["tiles"]){
				for each (var tile:CodeRunnerHandle in row){
					tile.unload(mroot.hold);
				}
			}
			for each (var enemy:CodeRunnerHandle in handles["enemies"]){
				enemy.unload(mroot.hold);
			}
			for each (var collectible:CRCollectible in handles["collectibles"]){
				collectible.unload(mroot.hold);
			}
			for each (var sign:MovieClip in handles["signs"]){
				mroot.hold.removeChild(sign);
			}
			handles["player"].unload(mroot.hold);
			handles["exit"].unload(mroot.hold);
			mroot.hold.removeChild(handles["hud"]);
			mroot.hold.removeChild(handles["bg"]);
			if (variables["gameover_shown"]){
				mroot.hold.removeChild(handles["gameover"]);
			}
			
			variables["exit_opened"] = false;
			variables["counters"]["score"] = intervariables["score"];
		}
		
		private function loadGame():void {
			variables["lvl_loaded"] = resources["levels"][intervariables["load_level"]];
			variables["gameover_shown"] = false;
			
			handles["bg"] = new resources["ts1_bg"]();
			mroot.hold.addChild(handles["bg"]);
			
			handles["hud"] = new resources["hud"]();
			handles["hud"].x = 0;
			handles["hud"].y = 450;
			mroot.hold.addChild(handles["hud"]);
			
			handles["tiles"] = new Array();
			handles["enemies"] = new Array();
			handles["collectibles"] = new Array();
			handles["signs"] = new Array();
			var addPlayerX:int = -1;
			var addPlayerY:int = -1;
			for (var ys:int = 0; ys < variables["lvl_loaded"].length; ys++){
				var row:Array = variables["lvl_loaded"][ys];
				for (var xs:int = 0; xs < row.length; xs++){
					if (handles["tiles"].length == xs){
						handles["tiles"][xs] = new Array();
					}
					switch (row[xs]){
						case 0:
						handles["tiles"][xs][ys] = new CRNoTerrain();
						break;
						case 1:
						handles["tiles"][xs][ys] = new CRHardTerrain(mroot.hold, resources["ts1_hard"], variables["lvl_loaded"], xs, ys);
						break;
						case 2:
						handles["tiles"][xs][ys] = new CRSoftTerrain(mroot.hold, resources["ts1_soft"], resources["sounds"]["burn"], variables["lvl_loaded"], xs, ys);
						break;
						case 3:
						addPlayerX = xs;
						addPlayerY = ys;
						handles["tiles"][xs][ys] = new CRNoTerrain();
						break;
						case 4:
						handles["enemies"][handles["enemies"].length] = new CREnemy1(mroot.hold, resources["enemy1"], xs, ys);
						handles["tiles"][xs][ys] = new CRNoTerrain();
						break;
						case 5:
						handles["collectibles"][handles["collectibles"].length] = new CRCollectible(mroot.hold, resources["col1"], 100, xs, ys);
						handles["tiles"][xs][ys] = new CRNoTerrain();
						break;
						case 6:
						handles["collectibles"][handles["collectibles"].length] = new CRCollectible(mroot.hold, resources["col2"], 250, xs, ys);
						handles["tiles"][xs][ys] = new CRNoTerrain();
						break;
						case 7:
						handles["tiles"][xs][ys] = new CRLadder(mroot.hold, resources["ts1_ladder"], variables["lvl_loaded"], xs, ys);
						break;
						case 9:
						handles["exit"] = new CRExit(mroot.hold, resources["ts1_exit"], xs, ys);
						handles["tiles"][xs][ys] = new CRNoTerrain();
						break;
						case 11:
						var newSign:int = handles["signs"].length;
						handles["signs"][newSign] = new resources["signs"][intervariables["load_level"]][newSign]();
						handles["signs"][newSign].x = (xs * 30) + 5;
						handles["signs"][newSign].y = ys * 30;
						mroot.hold.addChild(handles["signs"][newSign]);
						break;
					}
				}
			}
			if (addPlayerX != -1 && addPlayerY != -1){
				handles["player"] = new CRPlayer(mroot.hold, resources["player"], resources["sounds"]["death"], addPlayerX, addPlayerY);
			}
		}
	}
}