﻿package spec.coderunner.types {
	import flash.display.MovieClip;
	import spec.coderunner.CodeRunnerHandle;

	public class CREnemy1 extends spec.coderunner.CodeRunnerHandle {
		override public function getType():String {
			return "enemy1";
		}
		
		override public function unload(hold:MovieClip):void {
			hold.removeChild(mcHandle);
		}
		
		public function CREnemy1(hold:MovieClip, enemy:Class, xp:int, yp:int){
			mcHandle = new enemy();
			mcHandle.gotoAndStop(1);
			mcHandle.x = (xp * 30) + 5;
			mcHandle.y = yp * 30;
			xpos = xp;
			ypos = yp;
			startX = xp;
			startY = yp;
			hold.addChild(mcHandle);
		}
		
		private var enemy_state:String = "idle";
		private var enemy_clock:int = 0;
		
		private var startX:int;
		private var startY:int;
		
		public var xpos:int;
		public var ypos:int;
		
		public function clock(player:CRPlayer, tilemap:Array, enemies:Array){
			if (enemy_clock > 0){
				enemy_clock--;
			} else {
				switch (enemy_state){
					case "falling":
					ypos += 1;
					mcHandle.y += 30;
					enemy_clock = 0;
					break;
					case "walk_left":
					xpos -= 1;
					mcHandle.x -= 30;
					enemy_clock = 0;
					break;
					case "walk_right":
					xpos += 1;
					mcHandle.x += 30;
					enemy_clock = 0;
					break;
					case "dead":
					xpos = startX;
					ypos = startY;
					mcHandle.x = (xpos * 30) + 5;
					mcHandle.y = ypos * 30;
					enemy_state = "respawn";
					enemy_clock = 3;
					mcHandle.gotoAndPlay("respawn");
					break;
				}
				if (enemy_clock == 0){
					enemy_state = "idle";
					enemy_clock = 0;
					mcHandle.gotoAndStop("idle");
				}
			}
			
			if (enemy_state == "idle"){
				if (tilemap[xpos][ypos].lethal()){
					enemy_state = "dead";
					enemy_clock = 40;
					mcHandle.gotoAndPlay("death");
				}
			}
			
			if (enemy_state == "idle"){
				if (ypos != tilemap[0].length - 1 && tilemap[xpos][ypos + 1].walkable(enemies)){
					enemy_state = "falling";
					enemy_clock = 7;
					mcHandle.gotoAndPlay("falling");
				}
			}
			
			if (enemy_state == "idle" && !player.isDead){
				if (player.ypos == ypos && player.xpos + 1 == xpos){
					enemy_state = "attack_left";
					enemy_clock = 4;
					mcHandle.gotoAndPlay("attack_left");
					player.kill();
				} else if (player.ypos == ypos && player.xpos -1 == xpos){
					enemy_state = "attack_right";
					enemy_clock = 4;
					mcHandle.gotoAndPlay("attack_right");
					player.kill();
				}
			}
			
			if (enemy_state == "idle" && !player.isDead){
				if ((player.xpos < xpos || player.xpos == xpos) && xpos != 0 && tilemap[xpos - 1][ypos].walkable(enemies)){
					enemy_state = "walk_left";
					enemy_clock = 15;
					mcHandle.gotoAndPlay("walk_left");
				} else if ((player.xpos > xpos || player.xpos == xpos) && xpos != tilemap.length && tilemap[xpos + 1][ypos].walkable(enemies)){
					enemy_state = "walk_right";
					enemy_clock = 15;
					mcHandle.gotoAndPlay("walk_right");
				}
			}
		}
	}
}