﻿package spec.coderunner.types {
	import spec.coderunner.CodeRunnerTerrain;
	import flash.display.MovieClip;

	public class CRLadder extends CodeRunnerTerrain {
		override public function getType():String {
			return "ladder";
		}
		
		override public function walkable(enemies:Array):Boolean {
			return true;
		}
		
		override public function climbable():Boolean {
			return true;
		}
		
		public var xpos:int;
		public var ypos:int;
		
		public function CRLadder(hold:MovieClip, ladder:Class, tileMap:Array, xp:int, yp:int){
			mcHandle = new ladder();
			mcHandle.x = (xp * 30) + 5;
			mcHandle.y = yp * 30;
			xpos = xp;
			ypos = yp;
			
			var noTop:Boolean = false;
			var noBottom:Boolean = false;
			
			if (ypos == 0 || tileMap[ypos - 1][xpos] != 7){
				noTop = true;
			}
			if (ypos == tileMap.length - 1 || tileMap[ypos + 1][xpos] != 7){
				noBottom = true;
			}
			
			if (noTop && !noBottom){
				mcHandle.gotoAndStop(2);
			} else if (!noTop && noBottom){
				mcHandle.gotoAndStop(3);
			} else if (noTop && noBottom){
				mcHandle.gotoAndStop(4);
			} else {
				mcHandle.gotoAndStop(1);
			}
			hold.addChild(mcHandle);
		}
	}
}