﻿package spec.coderunner.types {
	import flash.display.MovieClip;
	import spec.coderunner.CodeRunnerHandle;
	import flash.media.Sound;

	public class CRPlayer extends spec.coderunner.CodeRunnerHandle {
		override public function getType():String {
			return "player";
		}
		
		override public function unload(hold:MovieClip):void {
			hold.removeChild(mcHandle);
		}
		
		private var deathS:Sound;
		
		public function CRPlayer(hold:MovieClip, player:Class, deathSound:Class, xp:int, yp:int){
			mcHandle = new player();
			mcHandle.gotoAndStop(1);
			mcHandle.x = (xp * 30) + 5;
			mcHandle.y = yp * 30;
			
			deathS = new deathSound();
			
			xpos = xp;
			ypos = yp;
			hold.addChild(mcHandle);
		}
		
		public function kill(){
			deathS.play(0, 1);
			player_state = "dead";
			mcHandle.gotoAndPlay("death");
			isDead = true;
		}
		
		public var isDead:Boolean = false;
		
		private var player_state:String = "idle";
		private var player_clock:int = 0;
		
		public var xpos:int;
		public var ypos:int;
		
		public function clock(aLeft:Boolean, aUp:Boolean, aRight:Boolean, aDown:Boolean, bLeft:Boolean, bRight:Boolean, tilemap:Array, enemies:Array){
			var onLadder:Boolean = false;
			
			if (player_clock > 0){
				player_clock--;
			} else if (player_state != "dead"){
				switch (player_state){
					case "falling":
					ypos += 1;
					mcHandle.y += 30;
					break;
					case "walk_left":
					xpos -= 1;
					mcHandle.x -= 30;
					break;
					case "walk_right":
					xpos += 1;
					mcHandle.x += 30;
					break;
					case "climb_up":
					ypos -= 1;
					mcHandle.y -= 30;
					break;
					case "climb_down":
					ypos += 1;
					mcHandle.y += 30;
					break;
				}
				player_state = "idle";
				player_clock = 0;
				if (ypos != tilemap[0].length - 1 && tilemap[xpos][ypos + 1].walkable(enemies) && tilemap[xpos][ypos + 1].climbable() && tilemap[xpos][ypos].climbable()){
					mcHandle.gotoAndStop("climb_idle");
				} else {
					mcHandle.gotoAndStop("idle");
				}
			}
			
			if (player_state == "idle"){
				if (tilemap[xpos][ypos].lethal()){
					kill();
				}
			}
			
			if (player_state == "idle"){
				if (ypos != tilemap[0].length - 1 && tilemap[xpos][ypos + 1].walkable(enemies) && !tilemap[xpos][ypos + 1].climbable()){
					player_state = "falling";
					player_clock = 7;
					mcHandle.gotoAndPlay("falling");
				}
			}
			
			if (player_state == "idle"){
				if (bLeft && ypos != tilemap[0].length - 1 && xpos != 0 && tilemap[xpos - 1][ypos + 1].burnable()){
					player_state = "burn_left";
					player_clock = 7;
					tilemap[xpos - 1][ypos + 1].burn("topright");
					mcHandle.gotoAndPlay("burn_left");
				} else if (bRight && ypos != tilemap[0].length - 1 && xpos != tilemap.length && tilemap[xpos + 1][ypos + 1].burnable()){
					player_state = "burn_right";
					player_clock = 7;
					tilemap[xpos + 1][ypos + 1].burn("topleft");
					mcHandle.gotoAndPlay("burn_right");
				}
			}
			
			if (player_state == "idle"){
				if (aUp && ypos != 0 && tilemap[xpos][ypos].climbable()){
					player_state = "climb_up";
					player_clock = 7;
					mcHandle.gotoAndPlay("climb_up");
				} else if (aDown && ypos != tilemap[0].length && tilemap[xpos][ypos + 1].climbable()){
					player_state = "climb_down";
					player_clock = 7;
					mcHandle.gotoAndPlay("climb_down");
				}
			}
			
			if (player_state == "idle"){
				if (aLeft && xpos != 0 && tilemap[xpos - 1][ypos].walkable(enemies)){
					player_state = "walk_left";
					player_clock = 7;
					mcHandle.gotoAndPlay("walk_left");
				} else if (aRight && xpos != tilemap.length && tilemap[xpos + 1][ypos].walkable(enemies)){
					player_state = "walk_right";
					player_clock = 7;
					mcHandle.gotoAndPlay("walk_right");
				}
			}
		}
	}
}