﻿package spec.coderunner.types {
	import flash.display.MovieClip;
	import spec.coderunner.CodeRunnerHandle;
	import flash.events.Event;
	import flash.media.Sound;

	public class CRSoftTerrain extends spec.coderunner.CodeRunnerTerrain {
		override public function getType():String {
			return "soft";
		}
		
		private var clockTime:int = 0;
		
		private function clock(e:Event):void {
			if (clockTime == 4){
				mcHandle.core.gotoAndPlay("growback");
				clockTime--;
			} else if (clockTime == 0){
				mcHandle.core.gotoAndStop("idle");
			} else {
				clockTime--;
			}
		}
		
		override public function lethal():Boolean {
			return clockTime < 5 ? true : false;
		}
		
		override public function walkable(enemies:Array):Boolean {
			if (clockTime == 0){
				return false;
			} else {
				for each (var enemy:CodeRunnerHandle in enemies){
					if (enemy is CREnemy1){
						var cr:CREnemy1 = enemy as CREnemy1;
						if (cr.xpos == xpos && cr.ypos == ypos){
							return false;
						}
					}
				}
				return true;
			}
		}
		
		override public function burnable():Boolean {
			return (clockTime == 0 ? true : false);
		}
		
		public function burn(style:String):void {
			mcHandle.core.gotoAndPlay("burn_" + style);
			clockTime = 160;
			burnS.play(0, 1);
		}
		
		public var xpos:int;
		public var ypos:int;
		
		private var burnS:Sound;
		
		public function CRSoftTerrain(hold:MovieClip, soft:Class, burnSound:Class, tileMap:Array, xp:int, yp:int){
			mcHandle = new soft();
			mcHandle.addEventListener(Event.ENTER_FRAME, clock);
			
			burnS = new burnSound();
			
			xpos = xp;
			ypos = yp;
			
			mcHandle.x = (xp * 30) + 5;
			mcHandle.y = yp * 30;
			
			var noLeft:Boolean = false;
			var noRight:Boolean = false;
			
			var row:Array = tileMap[ypos];
			
			if (xpos == 0 || (row[xpos - 1] != 1 && row[xpos - 1] != 2)){
				noLeft = true;
			}
			if (xpos == row.length - 1 || (row[xpos + 1] != 1 && row[xpos + 1] != 2)){
				noRight = true;
			}
			
			if (!noLeft && noRight){
				mcHandle.gotoAndStop(2);
			} else if (noLeft && !noRight){
				mcHandle.gotoAndStop(3);
			} else if (noLeft && noRight){
				mcHandle.gotoAndStop(4);
			} else {
				mcHandle.gotoAndStop(1);
			}
			hold.addChild(mcHandle);
		}
	}
}